<template>
  <v-layout wrap class="feedback-info pl-2">
    <v-flex xs12 v-if="open">
      <h2 class="font-weight-medium">{{title}}</h2>
    </v-flex>
    <v-flex xs12>
      <h3
        @click="showSeeMoreDialog"
        class="font-weight-medium"
        :class="{'feedback-info__sub-title' : !open,
        'feedback-info__truncate': open && feedbackText.length > 250}"
        v-html="feedbackText"
      ></h3>
    </v-flex>
    <v-flex v-if="open" class="py-2 feedback-info__translate" xs6 @click="toggleTranslated">
      <span>{{translatedLabel}}</span>
    </v-flex>
    <see-more-dialog :show="seeMoreDialog" @close="closeSeeMoreDialog" :feedback="feedback"/>
  </v-layout>
</template>

<script>
import SeeMoreDialog from './SeeMoreDialog';

export default {
  components: {
    SeeMoreDialog,
  },
  props: {
    feedback: {
      type: Object,
      default: () => ({}),
    },
    open: {
      type: Boolean,
      default: () => true,
    },
  },
  data() {
    return {
      translated: false,
      seeMoreDialog: false,
    };
  },
  methods: {
    toggleTranslated() {
      this.translated = !this.translated;
    },
    closeSeeMoreDialog() {
      this.seeMoreDialog = false;
    },
    showSeeMoreDialog(element) {
      const el = window.getComputedStyle(element.target, ':before');
      if (el.content === '"See more"') {
        this.seeMoreDialog = true;
      }
    },
  },
  computed: {
    title() {
      return this.feedback.correct ? "That's Correct!" : 'Uh-oh!';
    },
    feedbackText() {
      if (this.feedback.id || this.feedback.text.value) {
        return this.translated
          ? this.feedback.text.translation
          : this.feedback.text.value;
      }
      return '';
    },
    translatedLabel() {
      return this.translated ? 'Show Original' : 'Translate';
    },
  },
};
</script>

<style lang="sass">
  @import ~@/styles/defaults/mobileFirst

  .feedback-info
    &__truncate
      width: 100%
      overflow: hidden
      text-overflow: ellipsis
      display: -webkit-box
      -webkit-line-clamp: 3
      -webkit-box-orient: vertical
      word-wrap: break-word
      line-height: 1.2
      max-height: 4rem
      position: relative
      padding-right: 63px
      &:before
        content: 'See more'
        position: absolute
        right: 0px
        text-decoration: underline
        text-align: right
        bottom: 0
        cursor: pointer
    &__translate
      cursor: pointer
      text-decoration: underline
    &__sub-title
      max-height: 4rem
      overflow: hidden
      word-wrap: break-word
      padding-top: 10px
    +media-min-lg()
      &__truncate
        width: 100%
        &:before
          right: 0
</style>
